/*
 * globals.h
 *
 * program-wide variables for wiki2html
 */

#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdio.h>
#include "interpret.h"
#include "global.h"
#include "stralloc.h"
#include "pike_macros.h"
#include "module_support.h"
#include "mapping.h"
#include "threads.h"


struct Global_options
{
    char *base_url;
    char *image_url;
    char *document_title;
    char *program_name;
    char *stylesheet;

    FILE *input_file;
    FILE *output_file;

} Global;

#define CALLBACK_API_SIZE 7
#define cb_annotation    0x00
#define cb_linkInternal  0x01
#define cb_image         0x02
#define cb_hyperlink     0x03
#define cb_barelink      0x04
#define cb_embed         0x05
#define cb_pike          0x06


typedef struct 
{
  struct object *callbacks;
  int callbackOffsets[CALLBACK_API_SIZE];
  struct object               *obj;
  struct object                *fp;
  struct OutBlock*        outStart;
  struct OutBlock*      outCurrent;

} wiki_store;



#endif

